:- module infix.

:- interface.
:- import_module io.

:- pred main(state::di, state::uo) is det.

:- implementation.
:- import_module list, string, header, require, transform, char.

main -->
  read_header(List, File),
  transform_file(List, File).

/****
  print("The infix operators were: ["),
  write_list(List, ", ", print),
  print("]\n"). ***/

:- pred transform_file(list(string)::in, list(string)::in,
                       state::di, state::uo) is det.
transform_file(List, []) --> [].
transform_file(List, [Line|Rest]) -->
  transform_line(Line, List),
  transform_file(List, Rest).

:- pred transform_line(string::in, list(string)::in, 
                       state::di, state::uo) is det.
transform_line(String, List) -->
  transform(List, words(is_whitespace, String)), nl.
