:- module transform.

% examines each word in the file for transformation to the list/prefix
% notation, and then does so.

:- interface.
:- import_module io, list, string.

:- pred transform(list(string)::in, list(string)::in,
                  state::di, state::uo) is det.

:- implementation.
:- import_module string_utils, utils.

transform(_Infices, []) --> [].
transform(Infices, [Arg1|T]) -->
  { [Token|Rest] = T, 
    member(Token, Infices), 
    [Arg2|Remainder] = Rest,
    not(terminated(Arg1)) } ->
    format("%s `%s` %s ", [s(Arg1), s(Token), s(Arg2)]),
    transform(Infices, Remainder);
    format("%s ", [s(Arg1)]),
    transform(Infices, T).

:- pred terminated(string::in) is semidet.
terminated(Atom) :- any((pred(Terminator::in) is semidet :-
                          contains_char(Atom, Terminator)), [',', ';', '.']).
