:- module utils.

% some common utilities I use (any, every, etc)

:- interface.
:- import_module list.

:- pred any(pred(T), list(T)).
:- mode any(pred(in) is semidet, in) is semidet.
:- pred every(pred(T), list(T)).
:- mode every(pred(in) is semidet, in) is semidet.

:- implementation.
:- import_module bool.

any(Pred, Lst) :-
  Pred1 = (pred(A::in, B::out) is det :- Pred(A) -> B = yes; B = no),
  map(Pred1, Lst, Lst1),
  or_list(Lst1, Ans),
  Ans = yes -> true; fail.

every(Pred, List) :-
  Pred1 = (pred(A::in, B::in, C::out) is det :- Pred(A) -> C = B; C = no),
  foldl(Pred1, List, yes, Ans),
  Ans = yes -> true; fail.
